package main;

public class Car {
	
	private static final int[] CO2_GRAM_PER_MILE_ARRAY = {681, 625, 590, 562, 560, 466, 436, 425, 426, 424, 417, 407, 405, 407, 415, 420, 
		418, 427, 426, 436, 434, 435, 441, 442, 451, 450, 453, 457, 454, 461, 447, 442, 431, 424, 397, 394, 398, 376, 370};
	
	private Worker worker;
	private int modelYear;
	private int co2GramPerMile;
	private double co2GramPerKm;
	private Emission emission;
	
	public Car(Worker worker){
		this.worker = worker;
		emission = new Emission();
		modelYearAndEmission();
	}

	public void modelYearAndEmission(){
		int avgYear = 2003;
		int randomInterval = Start.random.nextInt(22)-11;
		modelYear = avgYear + randomInterval;
		int startYear = 1975;
		for (int co2GramPerMile : CO2_GRAM_PER_MILE_ARRAY) {
			if(startYear == modelYear){
				this.co2GramPerMile = co2GramPerMile;
				break;
			}
			startYear++;
		}
		co2GramPerKm = co2GramPerMile * ((double) 15625)/(25146);
		
	}

	public Worker getWorker() {
		return worker;
	}

	public void setWorker(Worker worker) {
		this.worker = worker;
	}

	public int getModelYear() {
		return modelYear;
	}

	public void setModelYear(int modelYear) {
		this.modelYear = modelYear;
	}

	public int getCo2GramPerMile() {
		return co2GramPerMile;
	}

	public void setCo2GramPerMile(int co2GramPerMile) {
		this.co2GramPerMile = co2GramPerMile;
	}

	public double getCo2GramPerKm() {
		return co2GramPerKm;
	}

	public void setCo2GramPerKm(double co2GramPerKm) {
		this.co2GramPerKm = co2GramPerKm;
	}

	public Emission getEmission() {
		return emission;
	}

	public void setEmission(Emission emission) {
		this.emission = emission;
	}
	
	public double drive(double km){
		return co2GramPerKm*km;
	}
	
}
