package main;

public class Emission {
	
	private static final double EL_GRAM_CARBON_PER_KWH = 143.88;
	private static final double NG_GRAM_CARBON_PER_MJ = 24.5;
	
	private String date;
	private double co2e;
	
	double co2eHomeOffice; //worker
	double co2ePersonalDevices; //worker
	double co2eHomeGeneralEl; //worker
	double co2eOffice; //office
	double co2eResidentialRelocation; //car
	double co2eCommuting; //car
	double co2eCarAvail; //worker
	double co2eCongestion; // car
	
	public Emission(){
		co2e = 0.0;
	}
	
	public Emission(double co2e){
		this.co2e = co2e;
	}
	
	public Emission(double co2e, String date){
		this.co2e = co2e;
		this.date = date;
	}

	public double getCo2e() {
		return co2e;
	}

	public void setCo2e(double co2e) {
		this.co2e = co2e;
	}
	
	public double btuToKwh(double btu){
		return (52752792631.0/180000000000000.0)*btu;
	}
	
	public double btuToMj(double btu){
		return (52752792631.0/50000000000000.0)*btu;
	}
	
	public double elKwhToCo2e(double kwh){
		return kwh*EL_GRAM_CARBON_PER_KWH;
	}
	
	public double ngMjToCo2e(double mj){
		return mj*NG_GRAM_CARBON_PER_MJ;
	}
	
	public double ngBtuToCo2e(double btu){
		return ngMjToCo2e(btuToMj(btu));
	}
	
	public void incrementCo2e(double co2e){
		this.co2e += co2e;
	}
	
	public void setDate(String date){
		this.date = date;
	}
	
	public String getDate(){
		return date;
	}
	
	public String toString(){
		return "" + co2e;
	}

}
