package main;

public class Month {
	private int id;
	private String name;
	private int highTemp;
	private int lowTemp;
	private double avgTemp;
	private int season;
	private double seasonalMultipler;
	private int todaysTemp;
	
	private double seasonHot;
	private double seasonCold;
	private double seasonTypical;
	
	public Month(String name, int id , int highTemp, int lowTemp) {
		this.name = name;
		this.id = id;
		this.highTemp = highTemp;
		this.lowTemp = lowTemp;
		avgTemp = lowTemp + ((highTemp-lowTemp)/2);
		season = setSeason();
	}
	
	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public String getName(){
		return name;
	}

	public int getHighTemp() {
		return highTemp;
	}

	public void setHighTemp(int highTemp) {
		this.highTemp = highTemp;
	}

	public int getLowTemp() {
		return lowTemp;
	}

	public void setLowTemp(int lowTemp) {
		this.lowTemp = lowTemp;
	}

	public double getAvgTemp() {
		return avgTemp;
	}

	public void setAvgTemp(int avgTemp) {
		this.avgTemp = avgTemp;
	}

	public void setName(String name) {
		this.name = name;
	}
	
	public int getTodaysTemp() {
		return todaysTemp;
	}
	
	public void setTemperature(){
		//todaysTemp = lowTemp + Start.random.nextInt((highTemp-lowTemp));
		todaysTemp = (int) (Start.random.nextGaussian()*(Math.sqrt(highTemp-avgTemp)) + avgTemp);
	}
	
	public int getSeason() {
		return season;
	}

	public void setSeason(int season) {
		this.season = season;
	}

	public double getSeasonalMultipler() {
		return seasonalMultipler;
	}

	public void setSeasonalMultipler(double seasonalMultipler) {
		this.seasonalMultipler = seasonalMultipler;
	}

	public int setSeason(){
		if(id == 12 || id == 1 || id == 2){
			//winter
			seasonalMultipler = .80;
			return 0;
		}
		else if (id == 3 || id == 4 || id == 5) {
			// spring
			seasonalMultipler = 1.0;
			return 1;
		}
		else if (id == 6 || id == 7 || id == 8) {
			// summer
			seasonalMultipler = 1.2;
			return 2;
		}
		else if (id == 9 || id == 10 || id == 11) {
			// fall
			seasonalMultipler = 1.0;
			return 3;
		}
		else {
			return -1;
		}
	}
	
	public double todaysTemperatureModifier(){
		double a = highTemp-avgTemp;
		double b = todaysTemp-avgTemp;
		if(b == 0.0){
			return 1.0;
		}
		else if (b > 0.0){
			return 1.0 + 0.20*(b/a);
		}
		else {
			return 1.0 + 0.20*(b/a);
		}
	}
}