package main;

public class Worker implements Comparable<Worker> {
	private static final double[] TELECOMMUTING_DAYS_FREQUENCY = {.37, .39, .13, .08, .03};
	
	private Home home;
	private Car car;
	private Office office;
	private boolean[] tcDays = new boolean[5];
	private Emission emission;
	private int tcYear;
	
	public Worker(){
		emission = new Emission();
	}

	public Emission getEmission() {
		return emission;
	}

	public void setEmission(Emission emission) {
		this.emission = emission;
	}

	public Home getHome() {
		return home;
	}

	public void setHome(Home home) {
		this.home = home;
	}

	public Car getCar() {
		return car;
	}

	public void setCar(Car car) {
		this.car = car;
	}

	public Office getOffice() {
		return office;
	}
	
	public int getTcYear(){
		return tcYear;
	}
	
	public void setTcYear(int tcYear){
		this.tcYear = tcYear;
	}

	public void setOffice(Office office) {
		this.office = office;
	}

	public boolean[] getTcDays() {
		return tcDays;
	}

	public void setTcDays(boolean[] tcDays) {
		this.tcDays = tcDays;
	}
	
	public boolean isTelecommuter(){
		for (boolean day : tcDays) {
			if (day){
				return true;
			}
		}
		return false;
	}
	
	public void becomeTelecommuter(){
		double random = Start.random.nextDouble();
		double sum = 0.0;
		int numberOfTcDays = 0;
		for (double tdf : TELECOMMUTING_DAYS_FREQUENCY) {
			sum += tdf;
			numberOfTcDays++;
			if(random < sum){
				break;
			}
		}
		int assignedDays = 0;
		while (assignedDays < numberOfTcDays){
			int dayOfWeek = Start.random.nextInt(5);
			if (!tcDays[dayOfWeek]){
				tcDays[dayOfWeek] = true;
				assignedDays++;
			}
		}
		office.addTelecommuter(this);
	}

	public int compareTo(Worker worker) {
		return (int) (home.getDistanceToOffice()*1000) - (int) (worker.getHome().getDistanceToOffice()*1000);
	}
	
	public String toString(){
		return "TC: " + isTelecommuter() + ", Days: " + tcDays[0] + tcDays[1] + tcDays[2] + tcDays[3] + tcDays[4]; 
	}
}